Index: trunk/LMDZ.MARS/libf/aeronomars/jthermcalc.F
===================================================================
--- trunk/LMDZ.MARS/libf/aeronomars/jthermcalc.F	(revision 1265)
+++ trunk/LMDZ.MARS/libf/aeronomars/jthermcalc.F	(revision 1266)
@@ -1,5 +1,6 @@
 c**********************************************************************
 
-      subroutine jthermcalc(ig,chemthermod,rm,nesptherm,tx,iz,zenit)
+      subroutine jthermcalc(ig,nlayer,chemthermod,
+     .      rm,nesptherm,tx,iz,zenit)
 
 
@@ -11,42 +12,41 @@
 c**********************************************************************
 
+      use param_v4_h, only: jfotsout,crscabsi2,
+     .    c1_16,c17_24,c25_29,c30_31,c32,c33,c34,c35,c36,
+     .    co2crsc195,co2crsc295,t0,
+     .    jabsifotsintpar,ninter,nz2
+
       implicit none
 
-c     common variables and constants
-      include "dimensions.h"
-      include "dimphys.h"
-      include 'param.h'
-      include 'param_v4.h'
-
 c     input and output variables
 
-      integer    ig
+      integer    ig,nlayer
       integer    chemthermod
       integer    nesptherm                      !Number of species considered
-      real       rm(nlayermx,nesptherm)         !Densities (cm-3)
-      real       tx(nlayermx)                   !temperature
+      real       rm(nlayer,nesptherm)         !Densities (cm-3)
+      real       tx(nlayer)                   !temperature
       real       zenit                          !SZA
-      real       iz(nlayermx)                   !Local altitude
+      real       iz(nlayer)                   !Local altitude
 
 
 c    local parameters and variables
 
-      real       co2colx(nlayermx)              !column density of CO2 (cm^-2)
-      real       o2colx(nlayermx)               !column density of O2(cm^-2)
-      real       o3pcolx(nlayermx)              !column density of O(3P)(cm^-2)
-      real       h2colx(nlayermx)               !H2 column density (cm-2)
-      real       h2ocolx(nlayermx)              !H2O column density (cm-2)
-      real       h2o2colx(nlayermx)             !column density of H2O2(cm^-2)
-      real       o3colx(nlayermx)               !O3 column density (cm-2)
-      real       n2colx(nlayermx)               !N2 column density (cm-2)
-      real       ncolx(nlayermx)                !N column density (cm-2)
-      real       nocolx(nlayermx)               !NO column density (cm-2)
-      real       cocolx(nlayermx)               !CO column density (cm-2)
-      real       hcolx(nlayermx)                !H column density (cm-2)
-      real       no2colx(nlayermx)              !NO2 column density (cm-2)
-      real       t2(nlayermx)
-      real       coltemp(nlayermx)
-      real       sigma(ninter,nlayermx)
-      real       alfa(ninter,nlayermx)
+      real       co2colx(nlayer)              !column density of CO2 (cm^-2)
+      real       o2colx(nlayer)               !column density of O2(cm^-2)
+      real       o3pcolx(nlayer)              !column density of O(3P)(cm^-2)
+      real       h2colx(nlayer)               !H2 column density (cm-2)
+      real       h2ocolx(nlayer)              !H2O column density (cm-2)
+      real       h2o2colx(nlayer)             !column density of H2O2(cm^-2)
+      real       o3colx(nlayer)               !O3 column density (cm-2)
+      real       n2colx(nlayer)               !N2 column density (cm-2)
+      real       ncolx(nlayer)                !N column density (cm-2)
+      real       nocolx(nlayer)               !NO column density (cm-2)
+      real       cocolx(nlayer)               !CO column density (cm-2)
+      real       hcolx(nlayer)                !H column density (cm-2)
+      real       no2colx(nlayer)              !NO2 column density (cm-2)
+      real       t2(nlayer)
+      real       coltemp(nlayer)
+      real       sigma(ninter,nlayer)
+      real       alfa(ninter,nlayer)
       
       integer    i,j,k,indexint                 !indexes
@@ -71,10 +71,10 @@
       real*8      auxjh(nz2)
       real*8      auxjno2(nz2)
-      real*8      wp(nlayermx),wm(nlayermx)
-      real*8      auxcolinp(nlayermx)
-      integer     auxind(nlayermx)
+      real*8      wp(nlayer),wm(nlayer)
+      real*8      auxcolinp(nlayer)
+      integer     auxind(nlayer)
       integer     auxi
       integer     ind
-      real*8      cortemp(nlayermx)
+      real*8      cortemp(nlayer)
 
       real*8      limdown                      !limits for interpolation
@@ -102,5 +102,5 @@
       !Auxiliar temperature to take into account the temperature dependence
       !of CO2 cross section
-      do i=1,nlayermx
+      do i=1,nlayer
          t2(i)=tx(i)
          if(t2(i).lt.195.0) t2(i)=195.0
@@ -109,5 +109,5 @@
 
       !Calculation of column amounts 
-      call column(ig,chemthermod,rm,nesptherm,tx,iz,zenit,
+      call column(ig,nlayer,chemthermod,rm,nesptherm,tx,iz,zenit,
      $     co2colx,o2colx,o3pcolx,h2colx,h2ocolx,
      $     h2o2colx,o3colx,n2colx,ncolx,nocolx,cocolx,hcolx,no2colx)
@@ -115,6 +115,6 @@
       !Auxiliar column to include the temperature dependence 
       !of CO2 cross section
-      coltemp(nlayermx)=co2colx(nlayermx)*abs(t2(nlayermx)-t0(nlayermx))
-      do i=nlayermx-1,1,-1
+      coltemp(nlayer)=co2colx(nlayer)*abs(t2(nlayer)-t0(nlayer))
+      do i=nlayer-1,1,-1
         coltemp(i)=!coltemp(i+1)+     PQ SE ELIMINA? REVISAR 
      $         ( rm(i,i_co2) + rm(i+1,i_co2) ) * 0.5 
@@ -123,5 +123,5 @@
       
       !Calculation of CO2 cross section at temperature t0(i)
-      do i=1,nlayermx
+      do i=1,nlayer
          do indexint=24,32
            sigma(indexint,i)=co2crsc195(indexint-23)
@@ -148,6 +148,6 @@
 c     Input atmospheric column
       indexint=1
-      do i=1,nlayermx
-         auxcolinp(nlayermx-i+1) = co2colx(i)*crscabsi2(1,indexint) +
+      do i=1,nlayer
+         auxcolinp(nlayer-i+1) = co2colx(i)*crscabsi2(1,indexint) +
      $        o2colx(i)*crscabsi2(2,indexint) + 
      $        o3pcolx(i)*crscabsi2(3,indexint) + 
@@ -159,5 +159,4 @@
       limdown=1.e-20
       limup=1.e26
-
 
 c     Interpolations
@@ -185,18 +184,18 @@
 
       call interfast 
-     $     (wm,wp,auxind,auxcolinp,nlayermx,auxcoltab,nz2,limdown,limup)
-      do i=1,nlayermx
+     $     (wm,wp,auxind,auxcolinp,nlayer,auxcoltab,nz2,limdown,limup)
+      do i=1,nlayer
          ind=auxind(i)
-         auxi=nlayermx-i+1
+         auxi=nlayer-i+1
          ! Ehouarn: test
           if ((ind+1.gt.nz2).or.(ind.le.0)) then
             write(*,*) "jthercalc error: ind=",ind,ig,zenit
-            write(*,*) " auxind(1:nlayermx)=",auxind
-            write(*,*) " auxcolinp(:nlayermx)=",auxcolinp
-            write(*,*) " co2colx(:nlayermx)=",co2colx
-            write(*,*) " o2colx(:nlayermx)=",o2colx
-            write(*,*) " o3pcolx(:nlayermx)=",o3pcolx
-            write(*,*) " h2colx(:nlayermx)=",h2colx
-            write(*,*) " ncolx(:nlayermx)=",ncolx
+            write(*,*) " auxind(1:nlayer)=",auxind
+            write(*,*) " auxcolinp(:nlayer)=",auxcolinp
+            write(*,*) " co2colx(:nlayer)=",co2colx
+            write(*,*) " o2colx(:nlayer)=",o2colx
+            write(*,*) " o3pcolx(:nlayer)=",o3pcolx
+            write(*,*) " h2colx(:nlayer)=",h2colx
+            write(*,*) " ncolx(:nlayer)=",ncolx
             write(*,*) " auxcoltab(1:nz2)=",auxcoltab
             write(*,*) " limdown=",limdown
@@ -220,7 +219,7 @@
       !N interpolated coefficient
       if(chemthermod.ge.2) then
-         do i=1,nlayermx
+         do i=1,nlayer
             ind=auxind(i)
-            jfotsout(indexint,9,nlayermx-i+1) =  wm(i)*auxjn(ind+1) +
+            jfotsout(indexint,9,nlayer-i+1) =  wm(i)*auxjn(ind+1) +
      $         wp(i)*auxjn(ind)
          enddo
@@ -241,6 +240,6 @@
 c     Input atmospheric column
       do indexint=2,15
-         do i=1,nlayermx
-            auxcolinp(nlayermx-i+1) = co2colx(i)*crscabsi2(1,indexint)+
+         do i=1,nlayer
+            auxcolinp(nlayer-i+1) = co2colx(i)*crscabsi2(1,indexint)+
      $           o2colx(i)*crscabsi2(2,indexint)+
      $           o3pcolx(i)*crscabsi2(3,indexint)+
@@ -288,9 +287,9 @@
          endif
 
-          call interfast(wm,wp,auxind,auxcolinp,nlayermx,
+          call interfast(wm,wp,auxind,auxcolinp,nlayer,
      $        auxcoltab,nz2,limdown,limup)
-          do i=1,nlayermx
+          do i=1,nlayer
              ind=auxind(i)
-             auxi = nlayermx-i+1
+             auxi = nlayer-i+1
              !O2 interpolated coefficient
              jfotsout(indexint,2,auxi) = wm(i)*auxjo2(ind+1) +
@@ -317,7 +316,7 @@
           !Only if chemthermod.ge.2
           if(chemthermod.ge.2) then
-             do i=1,nlayermx
+             do i=1,nlayer
                 ind=auxind(i)
-                auxi = nlayermx-i+1
+                auxi = nlayer-i+1
                 !N interpolated coefficient
                 jfotsout(indexint,9,auxi) = wm(i)*auxjn(ind+1) +
@@ -346,6 +345,6 @@
 c     Input atmospheric column
       indexint=16
-      do i=1,nlayermx
-         auxcolinp(nlayermx-i+1) = co2colx(i)*crscabsi2(1,indexint)+
+      do i=1,nlayer
+         auxcolinp(nlayer-i+1) = co2colx(i)*crscabsi2(1,indexint)+
      $        o2colx(i)*crscabsi2(2,indexint)+
      $        o3pcolx(i)*crscabsi2(3,indexint)+
@@ -393,8 +392,8 @@
 
       call interfast
-     $     (wm,wp,auxind,auxcolinp,nlayermx,auxcoltab,nz2,limdown,limup)
-      do i=1,nlayermx
+     $     (wm,wp,auxind,auxcolinp,nlayer,auxcoltab,nz2,limdown,limup)
+      do i=1,nlayer
          ind=auxind(i)
-         auxi = nlayermx-i+1
+         auxi = nlayer-i+1
          !O2 interpolated coefficient
          jfotsout(indexint,2,auxi) = wm(i)*auxjo2(ind+1) +
@@ -418,7 +417,7 @@
       !Only if chemthermod.ge.2
       if(chemthermod.ge.2) then
-         do i=1,nlayermx
+         do i=1,nlayer
             ind=auxind(i)
-            auxi = nlayermx-i+1
+            auxi = nlayer-i+1
             !N interpolated coefficient
             jfotsout(indexint,9,auxi) = wm(i)*auxjn(ind+1) +
@@ -444,6 +443,6 @@
 c     Input column
 
-      do i=1,nlayermx
-         auxcolinp(nlayermx-i+1) = co2colx(i) + o2colx(i) + n2colx(i) +
+      do i=1,nlayer
+         auxcolinp(nlayer-i+1) = co2colx(i) + o2colx(i) + n2colx(i) +
      $        nocolx(i) + cocolx(i) + no2colx(i)
       end do
@@ -478,9 +477,9 @@
 
          call interfast
-     $     (wm,wp,auxind,auxcolinp,nlayermx,auxcoltab,nz2,limdown,limup)
+     $     (wm,wp,auxind,auxcolinp,nlayer,auxcoltab,nz2,limdown,limup)
          !Correction to include T variation of CO2 cross section
          if(indexint.eq.24) then
-            do i=1,nlayermx
-               auxi = nlayermx-i+1
+            do i=1,nlayer
+               auxi = nlayer-i+1
                if(sigma(indexint,auxi)*
      $              alfa(indexint,auxi)*coltemp(auxi)
@@ -493,11 +492,11 @@
             enddo
          else
-            do i=1,nlayermx
+            do i=1,nlayer
                cortemp(i)=1.
             enddo
          end if
-         do i=1,nlayermx           
+         do i=1,nlayer           
             ind=auxind(i)
-            auxi = nlayermx-i+1
+            auxi = nlayer-i+1
             !O2 interpolated coefficient
             jfotsout(indexint,2,auxi) = (wm(i)*auxjo2(ind+1) +
@@ -519,7 +518,7 @@
          !Only if chemthermod.ge.2
          if(chemthermod.ge.2) then
-            do i=1,nlayermx
+            do i=1,nlayer
                ind=auxind(i)
-               auxi = nlayermx-i+1
+               auxi = nlayer-i+1
                !NO interpolated coefficient
                jfotsout(indexint,10,auxi)=(wm(i)*auxjno(ind+1) +
@@ -544,6 +543,6 @@
 c     Input atmospheric column
 
-      do i=1,nlayermx
-         auxcolinp(nlayermx-i+1) = co2colx(i) + o2colx(i) + h2ocolx(i) + 
+      do i=1,nlayer
+         auxcolinp(nlayer-i+1) = co2colx(i) + o2colx(i) + h2ocolx(i) + 
      $        h2o2colx(i) + nocolx(i) + cocolx(i) + no2colx(i)
       end do
@@ -579,8 +578,8 @@
          endif
          call interfast
-     $     (wm,wp,auxind,auxcolinp,nlayermx,auxcoltab,nz2,limdown,limup)
-         do i=1,nlayermx
+     $     (wm,wp,auxind,auxcolinp,nlayer,auxcoltab,nz2,limdown,limup)
+         do i=1,nlayer
             ind=auxind(i)
-            auxi = nlayermx-i+1
+            auxi = nlayer-i+1
             !Correction to include T variation of CO2 cross section
             if(sigma(indexint,auxi)*alfa(indexint,auxi)*
@@ -611,7 +610,7 @@
          !Only if chemthermod.ge.2
          if(chemthermod.ge.2) then
-            do i=1,nlayermx
+            do i=1,nlayer
                ind=auxind(i)
-               auxi = nlayermx-i+1
+               auxi = nlayer-i+1
                !NO interpolated coefficient
                jfotsout(indexint,10,auxi)=(wm(i)*auxjno(ind+1) +
@@ -638,6 +637,6 @@
 c     Input atmospheric column
 
-      do i=1,nlayermx
-         auxcolinp(nlayermx-i+1) = co2colx(i) + o2colx(i) + h2ocolx(i) + 
+      do i=1,nlayer
+         auxcolinp(nlayer-i+1) = co2colx(i) + o2colx(i) + h2ocolx(i) + 
      $        h2o2colx(i) + nocolx(i) + no2colx(i)
       end do
@@ -672,8 +671,8 @@
 
          call interfast
-     $     (wm,wp,auxind,auxcolinp,nlayermx,auxcoltab,nz2,limdown,limup)
-         do i=1,nlayermx
+     $     (wm,wp,auxind,auxcolinp,nlayer,auxcoltab,nz2,limdown,limup)
+         do i=1,nlayer
             ind=auxind(i)
-            auxi = nlayermx-i+1
+            auxi = nlayer-i+1
             !Correction to include T variation of CO2 cross section
             if(sigma(indexint,auxi)*alfa(indexint,auxi)*
@@ -701,7 +700,7 @@
          !Only if chemthermod.ge.2
          if(chemthermod.ge.2) then
-            do i=1,nlayermx 
+            do i=1,nlayer 
                ind=auxind(i)
-               auxi = nlayermx-i+1
+               auxi = nlayer-i+1
                !NO interpolated coefficient
                jfotsout(indexint,10,auxi)=(wm(i)*auxjno(ind+1) +
@@ -728,6 +727,6 @@
 
       indexint=32
-      do i=1,nlayermx
-         auxcolinp(nlayermx-i+1) =co2colx(i) + o2colx(i) + h2o2colx(i) + 
+      do i=1,nlayer
+         auxcolinp(nlayer-i+1) =co2colx(i) + o2colx(i) + h2o2colx(i) + 
      $        nocolx(i) + no2colx(i)
       end do
@@ -757,10 +756,10 @@
       endif
       call interfast
-     $     (wm,wp,auxind,auxcolinp,nlayermx,auxcoltab,nz2,limdown,limup)
-      do i=1,nlayermx
+     $     (wm,wp,auxind,auxcolinp,nlayer,auxcoltab,nz2,limdown,limup)
+      do i=1,nlayer
          ind=auxind(i)
-         auxi = nlayermx-i+1
+         auxi = nlayer-i+1
          !Correction to include T variation of CO2 cross section
-         if(sigma(indexint,nlayermx-i+1)*alfa(indexint,auxi)*
+         if(sigma(indexint,nlayer-i+1)*alfa(indexint,auxi)*
      $        coltemp(auxi).lt.60.) then
             cortemp(i)=exp(-sigma(indexint,auxi)*
@@ -783,6 +782,6 @@
       !Only if chemthermod.ge.2
       if(chemthermod.ge.2) then
-         do i=1,nlayermx
-            auxi = nlayermx-i+1
+         do i=1,nlayer
+            auxi = nlayer-i+1
             ind=auxind(i)
             !NO interpolated coefficient
@@ -808,6 +807,6 @@
 
       indexint=33
-      do i=1,nlayermx
-         auxcolinp(nlayermx-i+1) = o2colx(i) + h2o2colx(i) + no2colx(i)
+      do i=1,nlayer
+         auxcolinp(nlayer-i+1) = o2colx(i) + h2o2colx(i) + no2colx(i)
       end do
 
@@ -831,8 +830,8 @@
       endif
       call interfast
-     $     (wm,wp,auxind,auxcolinp,nlayermx,auxcoltab,nz2,limdown,limup)
-      do i=1,nlayermx
+     $     (wm,wp,auxind,auxcolinp,nlayer,auxcoltab,nz2,limdown,limup)
+      do i=1,nlayer
          ind=auxind(i)
-         auxi = nlayermx-i+1
+         auxi = nlayer-i+1
          !O2 interpolated coefficient
          jfotsout(indexint,2,auxi) = wm(i)*auxjo2(ind+1) +
@@ -844,8 +843,8 @@
       !Only if chemthermod.ge.2
       if(chemthermod.ge.2) then
-         do i=1,nlayermx
+         do i=1,nlayer
             ind=auxind(i)
             !NO2 interpolated coefficient
-            jfotsout(indexint,13,nlayermx-i+1) = wm(i)*auxjno2(ind+1) +
+            jfotsout(indexint,13,nlayer-i+1) = wm(i)*auxjno2(ind+1) +
      $           wp(i)*auxjno2(ind)
          enddo
@@ -865,6 +864,6 @@
 
       indexint=34
-      do i=1,nlayermx
-         auxcolinp(nlayermx-i+1) = h2o2colx(i) + o2colx(i) + o3colx(i) + 
+      do i=1,nlayer
+         auxcolinp(nlayer-i+1) = h2o2colx(i) + o2colx(i) + o3colx(i) + 
      $        no2colx(i)
       end do
@@ -891,8 +890,8 @@
       endif
       call interfast
-     $     (wm,wp,auxind,auxcolinp,nlayermx,auxcoltab,nz2,limdown,limup)
-      do i=1,nlayermx
+     $     (wm,wp,auxind,auxcolinp,nlayer,auxcoltab,nz2,limdown,limup)
+      do i=1,nlayer
          ind=auxind(i)
-         auxi = nlayermx-i+1
+         auxi = nlayer-i+1
          !O2 interpolated coefficient
          jfotsout(indexint,2,auxi) = wm(i)*auxjo2(ind+1) +
@@ -907,8 +906,8 @@
       !Only if chemthermod.ge.2
       if(chemthermod.ge.2) then
-         do i=1,nlayermx
+         do i=1,nlayer
             ind=auxind(i)
             !NO2 interpolated coefficient
-            jfotsout(indexint,13,nlayermx-i+1) = wm(i)*auxjno2(ind+1) +
+            jfotsout(indexint,13,nlayer-i+1) = wm(i)*auxjno2(ind+1) +
      $           wp(i)*auxjno2(ind)
          enddo
@@ -928,6 +927,6 @@
 
       indexint=35
-      do i=1,nlayermx
-         auxcolinp(nlayermx-i+1) = h2o2colx(i) + o3colx(i) + no2colx(i)
+      do i=1,nlayer
+         auxcolinp(nlayer-i+1) = h2o2colx(i) + o3colx(i) + no2colx(i)
       end do
 
@@ -951,8 +950,8 @@
       endif
       call interfast
-     $     (wm,wp,auxind,auxcolinp,nlayermx,auxcoltab,nz2,limdown,limup)
-      do i=1,nlayermx
+     $     (wm,wp,auxind,auxcolinp,nlayer,auxcoltab,nz2,limdown,limup)
+      do i=1,nlayer
          ind=auxind(i)
-         auxi = nlayermx-i+1
+         auxi = nlayer-i+1
          !H2O2 interpolated coefficient
          jfotsout(indexint,6,auxi) = wm(i)*auxjh2o2(ind+1) +
@@ -963,8 +962,8 @@
       enddo
       if(chemthermod.ge.2) then
-         do i=1,nlayermx
+         do i=1,nlayer
             ind=auxind(i)
             !NO2 interpolated coefficient
-            jfotsout(indexint,13,nlayermx-i+1) = wm(i)*auxjno2(ind+1) +
+            jfotsout(indexint,13,nlayer-i+1) = wm(i)*auxjno2(ind+1) +
      $           wp(i)*auxjno2(ind)
          enddo
@@ -983,6 +982,6 @@
 
       indexint=36
-      do i=1,nlayermx
-         auxcolinp(nlayermx-i+1) = o3colx(i) + no2colx(i)
+      do i=1,nlayer
+         auxcolinp(nlayer-i+1) = o3colx(i) + no2colx(i)
       end do
 
@@ -1004,17 +1003,17 @@
       endif
       call interfast
-     $     (wm,wp,auxind,auxcolinp,nlayermx,auxcoltab,nz2,limdown,limup)
-      do i=1,nlayermx
+     $     (wm,wp,auxind,auxcolinp,nlayer,auxcoltab,nz2,limdown,limup)
+      do i=1,nlayer
          ind=auxind(i)
          !O3 interpolated coefficient
-         jfotsout(indexint,7,nlayermx-i+1) = wm(i)*auxjo3(ind+1) +
+         jfotsout(indexint,7,nlayer-i+1) = wm(i)*auxjo3(ind+1) +
      $        wp(i)*auxjo3(ind)         
       enddo
       !Only if chemthermod.ge.2
       if(chemthermod.ge.2) then
-         do i=1,nlayermx
+         do i=1,nlayer
             ind=auxind(i)
             !NO2 interpolated coefficient
-            jfotsout(indexint,13,nlayermx-i+1) = wm(i)*auxjno2(ind+1) +
+            jfotsout(indexint,13,nlayer-i+1) = wm(i)*auxjno2(ind+1) +
      $           wp(i)*auxjno2(ind)
          enddo
@@ -1035,5 +1034,5 @@
 c**********************************************************************
 
-      subroutine column(ig,chemthermod,rm,nesptherm,tx,iz,zenit,
+      subroutine column(ig,nlayer,chemthermod,rm,nesptherm,tx,iz,zenit,
      $     co2colx,o2colx,o3pcolx,h2colx,h2ocolx,h2o2colx,o3colx,
      $     n2colx,ncolx,nocolx,cocolx,hcolx,no2colx)
@@ -1047,13 +1046,10 @@
      &                      igcm_o3, igcm_n2, igcm_n, igcm_no, igcm_no2,
      &                      mmol
+      use param_v4_h, only: radio,gg,masa,kboltzman,n_avog
+
       implicit none
 
 
 c     common variables and constants
-      include "dimensions.h"
-      include "dimphys.h"
-!      include "tracer.h"
-      include 'param.h'
-      include 'param_v4.h'
       include 'callkeys.h'
 
@@ -1066,46 +1062,46 @@
 c     input and output variables
 
-      integer    ig
+      integer    ig,nlayer
       integer    chemthermod
       integer    nesptherm                      !# of species undergoing chemistry, input
-      real       rm(nlayermx,nesptherm)         !densities (cm-3), input
-      real       tx(nlayermx)                   !temperature profile, input
-      real       iz(nlayermx+1)                 !height profile, input
+      real       rm(nlayer,nesptherm)         !densities (cm-3), input
+      real       tx(nlayer)                   !temperature profile, input
+      real       iz(nlayer+1)                 !height profile, input
       real       zenit                          !SZA, input
-      real       co2colx(nlayermx)              !column density of CO2 (cm^-2), output
-      real       o2colx(nlayermx)               !column density of O2(cm^-2), output
-      real       o3pcolx(nlayermx)              !column density of O(3P)(cm^-2), output
-      real       h2colx(nlayermx)               !H2 column density (cm-2), output
-      real       h2ocolx(nlayermx)              !H2O column density (cm-2), output
-      real       h2o2colx(nlayermx)             !column density of H2O2(cm^-2), output
-      real       o3colx(nlayermx)               !O3 column density (cm-2), output
-      real       n2colx(nlayermx)               !N2 column density (cm-2), output
-      real       ncolx(nlayermx)                !N column density (cm-2), output
-      real       nocolx(nlayermx)               !NO column density (cm-2), output
-      real       cocolx(nlayermx)               !CO column density (cm-2), output
-      real       hcolx(nlayermx)                !H column density (cm-2), output
-      real       no2colx(nlayermx)              !NO2 column density (cm-2), output
-      
+      real       co2colx(nlayer)              !column density of CO2 (cm^-2), output
+      real       o2colx(nlayer)               !column density of O2(cm^-2), output
+      real       o3pcolx(nlayer)              !column density of O(3P)(cm^-2), output
+      real       h2colx(nlayer)               !H2 column density (cm-2), output
+      real       h2ocolx(nlayer)              !H2O column density (cm-2), output
+      real       h2o2colx(nlayer)             !column density of H2O2(cm^-2), output
+      real       o3colx(nlayer)               !O3 column density (cm-2), output
+      real       n2colx(nlayer)               !N2 column density (cm-2), output
+      real       ncolx(nlayer)                !N column density (cm-2), output
+      real       nocolx(nlayer)               !NO column density (cm-2), output
+      real       cocolx(nlayer)               !CO column density (cm-2), output
+      real       hcolx(nlayer)                !H column density (cm-2), output
+      real       no2colx(nlayer)              !NO2 column density (cm-2), output
+
 
 c     local variables
 
       real       xx
-      real       grav(nlayermx)
+      real       grav(nlayer)
       real       Hco2,Ho3p,Ho2,Hh2,Hh2o,Hh2o2
       real       Ho3,Hn2,Hn,Hno,Hco,Hh,Hno2
 
-      real       co2x(nlayermx)
-      real       o2x(nlayermx)
-      real       o3px(nlayermx)
-      real       cox(nlayermx)
-      real       hx(nlayermx)
-      real       h2x(nlayermx)
-      real       h2ox(nlayermx)
-      real       h2o2x(nlayermx)
-      real       o3x(nlayermx)
-      real       n2x(nlayermx)
-      real       nx(nlayermx)
-      real       nox(nlayermx)
-      real       no2x(nlayermx)
+      real       co2x(nlayer)
+      real       o2x(nlayer)
+      real       o3px(nlayer)
+      real       cox(nlayer)
+      real       hx(nlayer)
+      real       h2x(nlayer)
+      real       h2ox(nlayer)
+      real       h2o2x(nlayer)
+      real       o3x(nlayer)
+      real       n2x(nlayer)
+      real       nx(nlayer)
+      real       nox(nlayer)
+      real       no2x(nlayer)
 
       integer    i,j,k,icol,indexint          !indexes
@@ -1117,7 +1113,7 @@
 
       integer    jj
-      real*8      esp(nlayermx*2)
-      real*8      ilayesp(nlayermx*2)
-      real*8      szalayesp(nlayermx*2)
+      real*8      esp(nlayer*2)
+      real*8      ilayesp(nlayer*2)
+      real*8      szalayesp(nlayer*2)
       integer     nlayesp
       real*8      zmini
@@ -1149,6 +1145,6 @@
 c*************************PROGRAM STARTS*******************************
 
-      nz3 = nlayermx*2
-      do i=1,nlayermx
+      nz3 = nlayer*2
+      do i=1,nlayer
          xx = ( radio + iz(i) ) * 1.e5
          grav(i) = gg * masa /(xx**2)
@@ -1156,5 +1152,5 @@
 
       !Scale heights
-      xx = kboltzman * tx(nlayermx) * n_avog / grav(nlayermx)
+      xx = kboltzman * tx(nlayer) * n_avog / grav(nlayer)
       Ho3p  = xx / mmol(igcm_o) 
       Hco2  = xx / mmol(igcm_co2)
@@ -1176,5 +1172,5 @@
       endif
       ! first loop in altitude : initialisation
-      do i=nlayermx,1,-1
+      do i=nlayer,1,-1
          !Column initialisation
          co2colx(i)  = 0.
@@ -1212,8 +1208,8 @@
       enddo
       ! second loop in altitude : column calculations
-      do i=nlayermx,1,-1
+      do i=nlayer,1,-1
          !Routine to calculate the geometrical length of each layer
-         call espesor_optico_A(ig,i,zenit,iz(i),nz3,iz,esp,ilayesp,
-     $         szalayesp,nlayesp, zmini)
+         call espesor_optico_A(ig,i,nlayer,zenit,iz(i),nz3,iz,esp,
+     $         ilayesp,szalayesp,nlayesp, zmini)
          if(ilayesp(nlayesp).eq.-1) then
             co2colx(i)=1.e25
@@ -1231,5 +1227,5 @@
             no2colx(i)=1.e25
          else
-            rcmnz = ( radio + iz(nlayermx) ) * 1.e5
+            rcmnz = ( radio + iz(nlayer) ) * 1.e5
             rcmmini = ( radio + zmini ) * 1.e5
             !Column calculation taking into account the geometrical depth 
@@ -1238,35 +1234,35 @@
                jj=ilayesp(j)
                !Top layer
-               if(jj.eq.nlayermx) then
+               if(jj.eq.nlayer) then
                   if(zenit.le.60.) then 
-                     o3pcolx(i)=o3pcolx(i)+o3px(nlayermx)*Ho3p*esp(j)
+                     o3pcolx(i)=o3pcolx(i)+o3px(nlayer)*Ho3p*esp(j)
      $                    *1.e-5
-                     co2colx(i)=co2colx(i)+co2x(nlayermx)*Hco2*esp(j)
+                     co2colx(i)=co2colx(i)+co2x(nlayer)*Hco2*esp(j)
      $                    *1.e-5
                      h2o2colx(i)=h2o2colx(i)+
-     $                    h2o2x(nlayermx)*Hh2o2*esp(j)*1.e-5
-                     o2colx(i)=o2colx(i)+o2x(nlayermx)*Ho2*esp(j)
+     $                    h2o2x(nlayer)*Hh2o2*esp(j)*1.e-5
+                     o2colx(i)=o2colx(i)+o2x(nlayer)*Ho2*esp(j)
      $                    *1.e-5
-                     h2colx(i)=h2colx(i)+h2x(nlayermx)*Hh2*esp(j)
+                     h2colx(i)=h2colx(i)+h2x(nlayer)*Hh2*esp(j)
      $                    *1.e-5
-                     h2ocolx(i)=h2ocolx(i)+h2ox(nlayermx)*Hh2o*esp(j)
+                     h2ocolx(i)=h2ocolx(i)+h2ox(nlayer)*Hh2o*esp(j)
      $                    *1.e-5                     
-                     cocolx(i)=cocolx(i)+cox(nlayermx)*Hco*esp(j)
+                     cocolx(i)=cocolx(i)+cox(nlayer)*Hco*esp(j)
      $                    *1.e-5
-                     hcolx(i)=hcolx(i)+hx(nlayermx)*Hh*esp(j)
+                     hcolx(i)=hcolx(i)+hx(nlayer)*Hh*esp(j)
      $                    *1.e-5
                      !Only if O3 chemistry required
                      if(chemthermod.ge.1) o3colx(i)=
-     $                    o3colx(i)+o3x(nlayermx)*Ho3*esp(j)
+     $                    o3colx(i)+o3x(nlayer)*Ho3*esp(j)
      $                    *1.e-5
                      !Only if N or ion chemistry requested
                      if(chemthermod.ge.2) then
-                        n2colx(i)=n2colx(i)+n2x(nlayermx)*Hn2*esp(j)
+                        n2colx(i)=n2colx(i)+n2x(nlayer)*Hn2*esp(j)
      $                    *1.e-5
-                        ncolx(i)=ncolx(i)+nx(nlayermx)*Hn*esp(j)
+                        ncolx(i)=ncolx(i)+nx(nlayer)*Hn*esp(j)
      $                       *1.e-5
-                        nocolx(i)=nocolx(i)+nox(nlayermx)*Hno*esp(j)
+                        nocolx(i)=nocolx(i)+nox(nlayer)*Hno*esp(j)
      $                       *1.e-5
-                        no2colx(i)=no2colx(i)+no2x(nlayermx)*Hno2*esp(j)
+                        no2colx(i)=no2colx(i)+no2x(nlayer)*Hno2*esp(j)
      $                       *1.e-5
                      endif
@@ -1290,21 +1286,21 @@
                         espno2=sqrt((rcmnz+Hno2)**2-rcmmini**2)- esp(j)
                      endif
-                     co2colx(i) = co2colx(i) + espco2*co2x(nlayermx)
-                     o2colx(i)  = o2colx(i)  + espo2*o2x(nlayermx)
-                     o3pcolx(i) = o3pcolx(i) + espo3p*o3px(nlayermx)
-                     h2colx(i)  = h2colx(i)  + esph2*h2x(nlayermx)
-                     h2ocolx(i) = h2ocolx(i) + esph2o*h2ox(nlayermx)
-                     h2o2colx(i)= h2o2colx(i)+ esph2o2*h2o2x(nlayermx)
-                     cocolx(i)  = cocolx(i)  + espco*cox(nlayermx)
-                     hcolx(i)   = hcolx(i)   + esph*hx(nlayermx)
+                     co2colx(i) = co2colx(i) + espco2*co2x(nlayer)
+                     o2colx(i)  = o2colx(i)  + espo2*o2x(nlayer)
+                     o3pcolx(i) = o3pcolx(i) + espo3p*o3px(nlayer)
+                     h2colx(i)  = h2colx(i)  + esph2*h2x(nlayer)
+                     h2ocolx(i) = h2ocolx(i) + esph2o*h2ox(nlayer)
+                     h2o2colx(i)= h2o2colx(i)+ esph2o2*h2o2x(nlayer)
+                     cocolx(i)  = cocolx(i)  + espco*cox(nlayer)
+                     hcolx(i)   = hcolx(i)   + esph*hx(nlayer)
                      !Only if O3 chemistry required
                      if(chemthermod.ge.1)                      
-     $                  o3colx(i) = o3colx(i)  + espo3*o3x(nlayermx)
+     $                  o3colx(i) = o3colx(i)  + espo3*o3x(nlayer)
                      !Only if N or ion chemistry requested
                      if(chemthermod.ge.2) then
-                        n2colx(i)  = n2colx(i)  + espn2*n2x(nlayermx)
-                        ncolx(i)   = ncolx(i)   + espn*nx(nlayermx)
-                        nocolx(i)  = nocolx(i)  + espno*nox(nlayermx)
-                        no2colx(i) = no2colx(i) + espno2*no2x(nlayermx)
+                        n2colx(i)  = n2colx(i)  + espn2*n2x(nlayer)
+                        ncolx(i)   = ncolx(i)   + espn*nx(nlayer)
+                        nocolx(i)  = nocolx(i)  + espno*nox(nlayer)
+                        no2colx(i) = no2colx(i) + espno2*no2x(nlayer)
                      endif
                   endif !Of if zenit.lt.60
@@ -1342,9 +1338,8 @@
      $                    esp(j) * (no2x(jj)+no2x(jj+1)) / 2.
                   endif
-               endif  !Of if jj.eq.nlayermx
+               endif  !Of if jj.eq.nlayer
             end do    !Of do j=1,nlayesp
          endif        !Of ilayesp(nlayesp).eq.-1
-
-      enddo           !Of do i=nlayermx,1,-1
+      enddo           !Of do i=nlayer,1,-1
 
 
@@ -1394,5 +1389,5 @@
 c**********************************************************************
 
-      subroutine espesor_optico_A (ig,capa, szadeg,z,
+      subroutine espesor_optico_A (ig,capa,nlayer, szadeg,z,
      @                   nz3,iz,esp,ilayesp,szalayesp,nlayesp, zmini)
 
@@ -1402,13 +1397,6 @@
 *************************************************************************
 
+      use param_v4_h, only: radio
       implicit none
-
-
-c     common variables and constants
-
-      include "dimensions.h"
-      include "dimphys.h"
-      include 'param.h'
-      include 'param_v4.h'
 
 c     arguments
